/*
The Solution to Problem 2 "Binary Shuffle" from ACM 2007
by:
	Ahmed Fikri - fikri@wisc.edu
	Computer Engineering - Freshman
Test cases included at the end of the code
*/

#include <fstream>
#include <iostream>
using namespace std;

bool array[7][7], temp, checking[1000];
int r,c,k,nr,nc, maxi, counter=0;
char ch;

void recurse (int, int, int, int);
void swap (int,int,int,int);
int getdec (int);

int main ()
{
	while (cin>>r){
	    if (r==0)
	        break;
	    counter++;
	    maxi=0;
	    cin>>c>>k;
	    
	    for (int i=0; i<1000; i++)
	        checking[i]=0;
	        
	    for (int i=1; i<=r; i++)
	        for (int j=1; j<=c; j++){
	            cin>>ch;
	            if (ch=='0' || ch=='1')
	                array[i][j]=(int)ch-(int)'0';
	            else{
	                array[i][j]=0;
	                nr=i;
	                nc=j;
	            }
	        }
	    recurse (nr,nc, 0,0);
	    
	    for (int i=0; i<1000; i++)
	        if (checking[i]) {
	            maxi++;
	            //cout<<i<<endl;
            }
	    cout<<"Case "<<counter<<": "<<maxi<<" binary numbers"<<endl;
	}
	return 0;
}

/*
The recursive function that iterates through all possible moves.
The part in the if statements. I used it check for the last step I made so that 
I dont go back to the direction again, in other words: so that I dont undo my
last move by doing a reverse move. this check makes the program run WAAAY faster
Following diagram explains what direction each number represent:
  1
4 X 2
  3
*/
void recurse (int a,int b, int moves, int dir)
{    
    if (moves==k)
    {
        for (int i=1; i<=r; i++)
            checking [getdec(i)]=1;
        return;
    }

    if (a>1 && dir!=3){
        swap (a,b,a-1,b);
        recurse (a-1,b,moves+1, 1);
        swap (a,b,a-1,b);
    }
    if (a<r && dir!=1){
        swap (a,b,a+1,b);
        recurse (a+1, b, moves+1, 3);
        swap (a,b,a+1,b);
    }
    if (b>1 && dir!=2){
        swap (a,b,a,b-1);
        recurse (a, b-1, moves+1, 4);
        swap (a,b,a,b-1);
    }
    if (b<c && dir!=4){
        swap (a,b,a,b+1);
        recurse (a, b+1, moves+1, 2);
        swap (a,b,a,b+1);
    }
}

void swap (int a, int b, int c, int d)
{
    temp=array[a][b];
    array[a][b]=array[c][d];
    array[c][d]=temp;
}

int getdec (int p)
{
    int count=1, number=0;
    for (int i=c; i>0; i--)
    {
        number+=(array[p][i]*count);
        count*=2;
    }
    return number;
}

/*
TEST CASES:

1- Answer: 64
5 6 15
1 0 1 1 0 1
0 1 1 0 1 1
1 x 0 1 1 1
0 1 0 1 0 1
1 1 1 0 1 1

2- Answer: 7
5 6 15
1 1 1 1 1 1
1 1 1 1 1 1
1 1 x 1 1 1
1 1 1 1 1 1
1 1 1 1 1 1

3- Answer: 1
5 6 15
0 0 0 0 0 0
0 0 0 0 0 0
0 0 x 0 0 0
0 0 0 0 0 0
0 0 0 0 0 0

4- Answer: 4
2 3 1
0 x 1
0 1 0

5- Answer: 3
2 2 2
0 x
1 0
*/