#include <iostream>

using namespace std;

struct Bridge
{
    enum { OPEN, EAST, WEST } dir;
    
    
    int east_cars, west_cars, ticks, wait_time;
    
    Bridge() : east_cars(0), west_cars(0), dir(OPEN), ticks(0), wait_time(0) {}

    void do_tick()
    {
        if(dir == OPEN)
        {
            if(east_cars > 0)
            {
                east_cars--;
                dir = EAST;
                wait_time = 60;
                
                //printf("t=%d\tBridge EAST\n", ticks);
            }
            else if(west_cars > 0)
            {
                west_cars--;
                dir = WEST;
                wait_time = 60;
                //printf("t=%d\tBridge WEST\n", ticks);
            }
        }
        else if(dir == EAST)
        {
            if(east_cars > 0)
            {
                east_cars--;
                wait_time = 60;
                
                //printf("t=%d\tEast car enter\n", ticks);
            }
        }
        else if(dir == WEST)
        {
            if(west_cars > 0)
            {
                west_cars--;
                wait_time = 60;
                //printf("t=%d\tWest car enter\n", ticks);
            }
        }
        
        if(wait_time > 0)
        {
            wait_time--;
            if(wait_time == 0)
            {
                dir = OPEN;
                
                //printf("t=%d\tBridge OPEN\n", ticks);
            }
        }
        
        ticks++;
    }
    
    void add_car(int d)
    {
        //printf("t=%d\tAdding car: %d\n", ticks, d);
        
        if(d == EAST)
            east_cars++;
        else if(d == WEST)
            west_cars++;
    }
    
    
    void run_ticks(int t)
    {
        for(int i=0; i<t; i++)
        {
            do_tick();
        }
    }
    
    int run_to_empty()
    {
        while(east_cars > 0 || west_cars > 0 || dir != OPEN)
            do_tick();
        return ticks;
    }
};

int main(int argc, char ** argv)
{
    int ncases;
    cin >> ncases;
    
    for(int casenum=1; casenum<=ncases; casenum++)
    {
        Bridge bridge;
        
        while(true)
        {
            int delta_t;
            char direction[10];
            
            cin >> delta_t;
            if(delta_t == -1)
                break;
            
            bridge.run_ticks(delta_t);
            cin >> direction;
            
            int x = Bridge::EAST;
            if(direction[0] == 'W')
                x = Bridge::WEST;
            bridge.add_car(x);
        }
        
        cout << "Case " << casenum << ". " << bridge.run_to_empty() << " seconds" << endl << endl;
    }
    
    return 0;
}
