//David Malec
//ACM North-Central regional contest 2007
//Problem #8

#include <iostream>
#include <cmath>

using namespace std;

#define eps 1e-7 //error margin for floating point calcs

int main(int argc, char* argv)
{
    int w, h; 
    double d;
    
    int casenum = 0;

    while(cin >> w >> h >> d && w + h > 0)
    {
	casenum++;

	double bestD;
	int bestX, bestY;
	
	int x, y;
	

	//for x = 0, just choose y closest to d by rounding
	y = (int)(d + .5 + eps);
	y = min(y, h);

	bestD = y;
	bestX = 0; 
	bestY = y;
	
	for(x = 1; x <= w; x++)
	{
	    //for each x, find y that would give the desired distance,
	    //and then round to nearest integer.
	    y = (int)(sqrt(d*d - x*x) + .5 + eps);
	    y = min(y, h); //don't go off paper!

	    double curD = sqrt(x*x + y*y);
	    if( abs(curD - d) + eps < abs(bestD - d))
	    {
		bestD = curD;
		bestX = x;
		bestY = y;
	    }
	}

	cout << "Case " << casenum << ": (" 
	     << bestX 
	     << "," 
	     << bestY 
	     << ")" 
	     << endl << endl;
    }
}
